// listdb.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "comdef.h"
#pragma warning (disable: 4146)
#import "c:\Program Files\Common Files\system\ado\msado15.dll"
#include "stdio.h"

const char* lpszConnection = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=BANKACC.MDB;Mode=ReadWrite|Share Deny None;Persist Security Info=False";
inline static void TESTHR(HRESULT x) {if FAILED(x) _com_issue_error(x);};

class COle
{
public:
	COle()
	{
		OleInitialize(NULL);
	};

	~COle()
	{
		OleUninitialize();
	};
};


int main(int argc, char* argv[])
{
	// Initialize OLE
	COle ole;

	try
	{
		HRESULT hr;
		_bstr_t user("");
		_bstr_t pass("");
		_variant_t count( (long) 0);

		ADODB::_ConnectionPtr dbConnection;
		ADODB::_RecordsetPtr dbRecordset;
		
		// create ADO connection
		TESTHR (hr = dbConnection.CreateInstance(__uuidof(ADODB::Connection)));
		dbConnection->Mode = (ADODB::ConnectModeEnum) (ADODB::adModeReadWrite | ADODB::adModeShareDenyNone);
		dbConnection->CommandTimeout = 0;
		TESTHR( hr = dbConnection->Open(lpszConnection,user,pass,ADODB::adConnectUnspecified));

		// execute query
		dbRecordset = dbConnection->Execute("SELECT * from BANK",&count,ADODB::adCmdText);

		while(!dbRecordset->GetEOF())
		{
			// output into stdout -> piped to xivr
			printf("%s, %s, %s, %d\n",
				(const char*) _bstr_t(dbRecordset->Fields->GetItem("AccNo")->Value),
				(const char*) _bstr_t(dbRecordset->Fields->GetItem("PIN")->Value),
				(const char*) _bstr_t(dbRecordset->Fields->GetItem("Name")->Value),
				(long) _variant_t(dbRecordset->Fields->GetItem("Balance")->Value));
			dbRecordset->MoveNext();
		}
		dbRecordset->Close();
		dbConnection->Close();
	}
	catch(_com_error& e)
	{
		const char* lpszError = e.ErrorMessage();
		printf("\r\n%s\r\n",lpszError);
		return -1;
	}
	return 0;
}
